- add verify and issue to cli
[oweals/gnunet.git] / src / credential / test_credential_lookup.sh
1 #!/bin/bash
2 trap "gnunet-arm -e -c test_credential_lookup.conf" SIGINT
3
4 LOCATION=$(which gnunet-config)
5 if [ -z $LOCATION ]
6 then
7   LOCATION="gnunet-config"
8 fi
9 $LOCATION --version 1> /dev/null
10 if test $? != 0
11 then
12         echo "GNUnet command line tools cannot be found, check environmental variables PATH and GNUNET_PREFIX"
13         exit 77
14 fi
15
16 rm -rf `gnunet-config -c test_credential_lookup.conf -s PATHS -o GNUNET_HOME -f`
17
18 #  (1) PKEY1.user -> PKEY2.resu.user
19 #  (2) PKEY2.resu -> PKEY3
20 #  (3) PKEY3.user -> PKEY4
21
22
23 which timeout &> /dev/null && DO_TIMEOUT="timeout 30"
24 TEST_ISSUER="PKEY1"
25 TEST_ATTR="user"
26 TEST_SUB_ATTR="resu"
27 TEST_DELEGATION_SUBJECT="PKEY2"
28 TEST_DELEGATION_ATTR="$TEST_SUB_ATTR.$TEST_ATTR"
29 TEST_SUBDELEGATION_SUBJECT="PKEY3"
30 TEST_SUBJECT="PKEY4"
31 TEST_CREDENTIAL="c1"
32 gnunet-arm -s -c test_credential_lookup.conf
33 gnunet-identity -C testone -c test_credential_lookup.conf
34 gnunet-identity -C testtwo -c test_credential_lookup.conf
35 gnunet-identity -C testthree -c test_credential_lookup.conf
36 gnunet-identity -C testfour -c test_credential_lookup.conf
37
38 #TODO1 Get credential and store it with subject (3)
39 CRED=`$DO_TIMEOUT gnunet-credential --issue --issuer=$TEST_SUBDELEGATION_SUBJECT --attribute=$TEST_SUB_ATTR --expiration 1m -c test_credential_lookup.conf`
40 gnunet-namestore -p -z testfour -a -n $TEST_CREDENTIAL -t CRED -V $CRED -e 5m -c test_credential_lookup.conf
41
42 # (1)
43 gnunet-namestore -p -z testone -a -n $TEST_ATTR -t ATTR -V "$TEST_DELEGATION_SUBJECT $TEST_DELEGATION_ATTR"
44
45 # (2)
46 gnunet-namestore -p -z testtwo -a -n $TEST_SUB_ATTR -t ATTR -V "$TEST_SUBDELEGATION_SUBJECT"
47
48
49 #TODO2 Add -z swich like in gnunet-gns
50 RES_IP=`$DO_TIMEOUT gnunet-credential --verify --issuer=$TEST_ISSUER --attribute="$TEST_DELEGATION_ATTR" --subject=$TEST_SUBJECT --credential=$TEST_CREDENTIAL -c test_credential_lookup.conf`
51
52 #TODO cleanup properly
53 gnunet-namestore -z testsubject -d -n newcred -t CRED -e never -c test_credential_lookup.conf
54 gnunet-identity -D testsubject -c test_credential_lookup.conf
55 gnunet-arm -e -c test_credential_lookup.conf
56
57 #TODO3 proper test
58 exit 0
59
60 #if [ "$RES_IP" == "$TEST_CRED" ]
61 #then
62 #  exit 0
63 #else
64 #  echo "FAIL: Failed to resolve to proper IP, got $RES_IP."
65 #  exit 1
66 #fi